#include <stdio.h>
#include <string.h>
#include "det.h"

int det(struct pci_device_array *device, int check_class)
{

	FILE *f, *devf;
	unsigned int devbusfn, id;
	int n, find_module();
	char buf[BUFSIZ], file[22];
	unsigned short *bufptr = (unsigned short *) &buf;

	if(!(f=fopen("/proc/bus/pci/devices", "r"))) {
		return(-1);
	}
	for(n=0;fgets(buf, sizeof(buf)-1, f);n++){
		sscanf(buf, "%x %x %x", &devbusfn, &id, &device[n].irq);
		device[n].pci_bus=devbusfn >> 8;
		device[n].pci_device=(devbusfn & 0xff) >> 3;
		device[n].pci_function=(devbusfn & 0xff) & 0x07;
		snprintf(file, 200, "/proc/bus/pci/%02x/%02x.%d",
		 device[n].pci_bus, device[n].pci_device, device[n].pci_function);
		if(!(devf=fopen(file, "r"))){
			continue;
		}
		fread(&buf, 0x30, 1, devf);
		device[n].vendor=bufptr[0x00];
		device[n].device=bufptr[0x01];
		device[n].class=bufptr[0x5];
		device[n].subvendor=bufptr[0x16];
		device[n].subdevice=bufptr[0x17];
		fclose(devf);
		if(check_class==PCI_ANY_CLASS)
			find_module(&device[n]);
		else if(device[n].class==check_class)
			find_module(&device[n]);
		else
			n--;
	}
	fclose(f);
	return(n-1);

}

int find_module(struct pci_device_array *device)
{

	FILE *file;
	unsigned int ven, dev, subven, subdev;
	int c, eindex();
	char buf[BUFSIZ];
	int find_video_driver();

	if(!(file=fopen("pcitable", "r"))){
		if(!(file=fopen("/usr/share/ldetect-lst/pcitable", "r"))){
			return(-1);
		}
	}
	while(fgets(buf, sizeof(buf)-1, file)){
		c=eindex(&buf,"0x");
		switch(c){
		case (4):
			sscanf(buf, "%x %x %x %x \"%[^\"] \"\t\"%[^\"]",
			 &ven, &dev, &subven, &subdev, device->module, device->name);
			if(ven==device->vendor && dev==device->device && 
			 subven==device->subvendor && subdev==device->subdevice){
				fclose(file);
				if(eindex(device->module,"Card:")>0)
					find_video_driver(device->module);
				return(0);
				break;
			}
		case (2):
			sscanf(buf, "%x %x \"%[^\"] \"\t\"%[^\"]",
			 &ven, &dev, device->module, device->name);
			if(ven==device->vendor && dev==device->device){
				fclose(file);
				if(eindex(device->module,"Card:")>0)
					find_video_driver(&device->module);
				return(0);
				break;
			}
		default:
			break;
		}
	}
	fclose(file);
	return(-1);

}

int eindex(char *s, char *t)
{

		int i, j, k;
		int count=0;
		for(i=0;s[i]!='\0';i++){
			for(j=i,k=0;t[k]!='\0' && s[j]==t[k];j++,k++)
				;
			if(t[k]=='\0')
				count++;
		}
		if(count!=0)
			return(count);
		return(-1);

}

int find_video_driver(char *cardname)
{

	struct cards {
			char name[100];
			char driver[15];
			int  clockp;
			char see[100];
	};
	struct cards cardsdb;

	FILE *card;
	char buf[BUFSIZ], tmp[BUFSIZ];
	int i=0;

	sscanf(cardname, "%[^:] :%[^\n]", tmp, cardname);
	while(1){
		if(!(card=fopen("Cards+", "r"))){
			if(!(card=fopen("/usr/share/ldetect-lst/Cards+", "r"))){
				sprintf(cardname, "unknown");
				return(-1);
			}
		}
		while(fgets(buf, sizeof(buf)-1, card)){
			if((strstr(buf,"NAME"))!=0 && (strstr(buf," NAME "))==0){
				sscanf(buf,"%s %[^\n]",tmp,cardsdb.name);
				cardsdb.clockp=0;
			}
			if((strstr(buf,"DRIVER"))!=0 && (strstr(buf,"DRIVER2"))==0){
				sscanf(buf,"%s %[^\n]",tmp,cardsdb.driver);
				sprintf(cardsdb.see,"%s","-");
			}
			if((strstr(buf,"NOCLOCKPROBE"))!=0 &&
			 (strstr(buf," NOCLOCKPROBE "))==0){
				cardsdb.clockp = 1;
			}
			if((strstr(buf,"SEE"))!=0 && (strstr(buf," SEE "))==0 &&
			 (strlen(cardsdb.name))!=0){
				sscanf(buf,"%s %[^\n]",tmp,cardsdb.see);
				sprintf(cardsdb.driver,"%s","-");
			}
			if((strcmp(cardname,cardsdb.name))==0){
				i++;
				if(strcmp(cardsdb.driver,"-")!=0){
					sprintf(cardname,"%s",cardsdb.driver);
					return(0);
				}
				else{
					sprintf(cardname,"%s",cardsdb.see);
					break;
				}
			}
		}
		fclose(card);
		if(i<1){
			sprintf(cardname, "unknown");
			break;
		}
		i--;
	}
	return(0);

}
